--[[
  Will convert buff text to "00:00" formated timers, in addition auras
  lasting longer than 15 minutes will turn semi-transparent, this helps you
  notice only the important buffs with low timers on them, in raids you get
  to rest your eyes -at least there will be less digits to focus on!
]]

local TimeLeft
do
  local d, h, m
  TimeLeft = function(s)
    d, h, m = 0, 0, 0
    if s >= 86400 then
      d = s/86400
      s = s%86400
    end
    if s >= 3600 then
      h = s/3600
      s = s%3600
    end
    if s >= 60 then
      m = s/60
      s = s%60
    end
    if d > 0 then
      return format("%.2d:%.2d", d, h)
    elseif h > 0 then
      return format("%.2d:%.2d", h, m)
    elseif m > 0 then
      return format("%.2d:%.2d", m, s)
    else
      if s < 3 then
        return format("|cffcc3333%.2f|r", s) -- red
      elseif s < 10 then
        return format("|cffcccc33%.1f|r", s) -- yellow
      else
        return format("%.1f", s) -- fallback value
      end
    end
    return ""
  end
end

hooksecurefunc("AuraButton_UpdateDuration", function(f, s)
  if SHOW_BUFF_DURATIONS ~= "1" then return end
  local d = f.duration
  if d then
    d:SetText(TimeLeft(s))
    d:SetAlpha(s > 900 and .5 or 1)
  end
end)
